## System Variables ##
TOP="/usr/bin/top -b -n 1" # top with options to do a printout
HEAD=/usr/bin/head
TAIL=/usr/bin/tail
SED=/bin/sed
AWK=/bin/awk
CAT=/bin/cat
ECHO=/bin/echo
RM=/bin/rm
BINMAIL=/bin/mail
MKDIR=/bin/mkdir
MV=/bin/mv

## Script Variables ##
SCRIPTHOME=/usr/local/boxhog/cpuchecker
TMPDIR="$SCRIPTHOME"/tmp
HOST=`/bin/hostname`
MAILTO="youraddress@yoursite.com"
SUBJECT="!!! $HOST CPU ALERT !!!"
MAXCPU=80 # Max cpu usage in percent

#################################
## DO NOT EDIT BELOW THIS LINE ##
#################################

cd $SCRIPTHOME

# checking if TMPDIR exists, if not create it.
if [ ! -d $TMPDIR ]; then
  $MKDIR $TMPDIR
fi

# getting the top output to a file
$TOP > $TMPDIR/top.out

$SED -e '/^$/d' $TMPDIR/top.out > $TMPDIR/top.sed

$SED -e 7,$\d $TMPDIR/top.sed > $TMPDIR/top.out

$SED -e 1,8\d $TMPDIR/top.sed > $TMPDIR/top.tmp

CURPROC=`"$CAT" "$TMPDIR"/top.tmp|"$HEAD" -1`

while [ -n "$CURPROC" ]
do
  CURCPU=`"$ECHO" "$CURPROC" | "$AWK" '{print $9}'`
  CURCPU=`"$ECHO" "$CURCPU" | "$AWK" -F. '{print $1}'`

  if [ "$CURCPU" -ge "$MAXCPU" ]; then
    if [ ! -f $TMPDIR/mail.tmp ]; then
      "$CAT" "$TMPDIR"/top.out > "$TMPDIR"/mail.tmp
      "$ECHO" "" >> "$TMPDIR"/mail.tmp
      "$ECHO" "The following process(es) are taking up greater than $MAXCPU percent of the CPU." >> "$TMPDIR"/mail.tmp
      "$ECHO" "" >> "$TMPDIR"/mail.tmp     
    fi
  
    "$ECHO" "$CURPROC" >> "$TMPDIR"/mail.tmp

  fi
   
    $SED -e 1d "$TMPDIR"/top.tmp > "$TMPDIR"/top.sed

    $MV -f "$TMPDIR"/top.sed "$TMPDIR"/top.tmp

    CURPROC=`"$CAT" "$TMPDIR"/top.tmp|"$HEAD" -1`    

done

# lets mail the results
if [ -f $TMPDIR/mail.tmp ]; then
  cat $TMPDIR/mail.tmp | $BINMAIL -s "$SUBJECT" "$MAILTO"
fi

$RM -rf $TMPDIR

exit 0
